## openio-sds 4.1.26

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project (OIOSDS C)

option(ENBUG "Introduces intentional bugs" OFF)
option(STACK_PROTECTOR "Instrument the code to detect stack smashings" OFF)
option(SOCKET_OPTIMIZED "Use Linux specific functions to save syscalls" ON)
option(FORBID_SLICE "Forbid playing with GLib2's slice allocators" OFF)
option(ALLOW_BACKTRACE "Attempt to compute backtraces when errors occur" OFF)
option(FORBID_DEPRECATED "Avoid the deprecated symbols of the GLib2" OFF)
option(ENABLE_CODECOVERAGE "Enable code coverage testing support" OFF)

include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckTypeSize)
include(FindFLEX)
include(FindBISON)
include(FindCURL)
include(FindPythonInterp)
include(FindZLIB)
find_package(PkgConfig)

if (NOT DEFINED OIOSDS_RELEASE)
	set(OIOSDS_RELEASE master)
endif ()
if (NOT DEFINED OIOSDS_PROJECT_VERSION_SHORT)
	set(OIOSDS_PROJECT_VERSION_SHORT "4.1")
endif ()

set(OIOSDS_PROJECT_VERSION "${OIOSDS_RELEASE}/${OIOSDS_PROJECT_VERSION_SHORT}")

if (NOT ABI_VERSION)
	set(ABI_VERSION 0)
endif()

set(CMAKE_C_FLAGS "-g -fPIC -pipe -Wall -Wextra -std=gnu99")
set(PYTHON python)

# necessary to benefit from zero'ed static allocation of structures
# as proposed by C99. (we only allocate the first field and let the compiler
# init the others to zero.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers")

if (CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-variadic-macros")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsequence-point")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wredundant-decls")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")

	# gcc >= 4.2
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcomment")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmain")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wparentheses")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfloat-equal")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunsafe-loop-optimizations")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-parameter")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-variable")

	# gcc >= 4.6
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wconversion")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wswitch-enum")
endif()

if ( ENABLE_CODECOVERAGE )

    if ( NOT DEFINED CODECOV_OUTPUTFILE )
        set( CODECOV_OUTPUTFILE cmake_coverage.output )
    endif ( NOT DEFINED CODECOV_OUTPUTFILE )

    if ( NOT DEFINED CODECOV_HTMLOUTPUTDIR )
        set( CODECOV_HTMLOUTPUTDIR coverage_results )
    endif ( NOT DEFINED CODECOV_HTMLOUTPUTDIR )


	set(CODECOV_PATTERN_TO_IGNORE
		"'${CMAKE_BINARY_DIR}/metautils/asn1c/*.*'"
		"'metautils/asn1c/*.*'")

    set(PYTHON_COVERAGE_FILE ${CMAKE_BINARY_DIR}/.python_coverage)
    set(PYTHON coverage run -p --source=${CMAKE_SOURCE_DIR})

    if ( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
        find_program( CODECOV_GCOV gcov )
        find_program( CODECOV_LCOV lcov )
        find_program( CODECOV_GENHTML genhtml )
        add_definitions( -fprofile-arcs -ftest-coverage )
        link_libraries( gcov )
        set( CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} --coverage )

        add_custom_target( coverage_init
                           ${CODECOV_LCOV} --base-directory ${CMAKE_SOURCE_DIR}  --directory ${CMAKE_BINARY_DIR} --output-file ${CODECOV_OUTPUTFILE} --capture --initial
                           COMMAND coverage erase)

        add_custom_target( coverage
						   ${CODECOV_LCOV} --base-directory ${CMAKE_SOURCE_DIR}  --directory ${CMAKE_BINARY_DIR} --no-external --output-file ${CODECOV_OUTPUTFILE} --capture
                           COMMAND ${CODECOV_LCOV} --output ${CODECOV_OUTPUTFILE} --remove ${CODECOV_OUTPUTFILE} ${CODECOV_PATTERN_TO_IGNORE}
						   COMMAND genhtml --ignore-errors source -o ${CODECOV_HTMLOUTPUTDIR} ${CODECOV_OUTPUTFILE}
                           COMMAND coverage combine
                           COMMAND coverage html)

    endif ( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
endif (ENABLE_CODECOVERAGE )

set(CMAKE_C_FLAGS_DEBUG          "-O0 -fno-inline")
set(CMAKE_C_FLAGS_RELEASE        "-O2")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -fno-inline")
set(CMAKE_C_FLAGS_MINSIZEREL     "-Os -s")

add_definitions(-D_REENTRANT)
add_definitions(-D_LARGE_FILES)
add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_LARGEFILE64_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DHAVE_SOCKLEN_T)
add_definitions(-DOIOSDS_PROJECT_VERSION="${OIOSDS_PROJECT_VERSION}")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
	add_definitions(-DG_ERRORCHECK_MUTEXES)
	add_definitions(-DHAVE_EXTRA_ASSERT=1)
	add_definitions(-DHAVE_EXTRA_DEBUG=1)
endif()

MESSAGE("OPTIONS:"
	" ENBUG=${ENBUG}"
	" SOCKET_OPTIMIZED=${SOCKET_OPTIMIZED}"
	" FORBID_SLICE=${FORBID_SLICE}"
	" STACK_PROTECTOR=${STACK_PROTECTOR}"
	" FORBID_DEPRECATED=${FORBID_DEPRECATED}"
	" ALLOW_BACKTRACE=${ALLOW_BACKTRACE}"
	" ENABLE_CODECOVERAGE=${ENABLE_CODECOVERAGE}")

if (ENBUG)
	MESSAGE(WARNING "ENBUGED MODE : NOT FOR PRODUCTION USE")
	add_definitions(-DHAVE_ENBUG=1)
endif()

if (STACK_PROTECTOR)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
endif()

if (SOCKET_OPTIMIZED)
	add_definitions(-D_GNU_SOURCE)
	add_definitions(-DHAVE_SOCKET3)
	add_definitions(-DHAVE_ACCEPT4)
endif()

if (FORBID_SLICE)
	add_definitions(-DHAVE_NO_SLICE)
endif()

if (ALLOW_BACKTRACE)
	add_definitions(-DHAVE_BACKTRACE)
endif()


if (FORBID_DEPRECATED)
	add_definitions(-DG_DISABLE_DEPRECATED=1)
endif ()

###-------------------------------------------------------------------------###

macro (dir2macro N)
	if (${N})
		add_definitions(-D${N}=${${N}})
		MESSAGE("CFLAGS: ${N} = ${${N}}")
	endif ()
endmacro ()

macro(test_CLI var msg)
	if (${var})
		MESSAGE(STATUS "FOUND CLI ${msg} : ${${var}}")
	else ()
		MESSAGE(FATAL_ERROR "NOT FOUND CLI ${msg}")
	endif ()
endmacro()

function (print_found arg)
	MESSAGE (STATUS "### ${arg} F=${${arg}_FOUND} V=${${arg}_VERSION} I=${${arg}_INCLUDE_DIRS} LD=${${arg}_LIBRARY_DIRS} L=${${arg}_LIBRARIES} H=${${arg}_HEADER}")
endfunction()

function (check_found)
	foreach (arg ${ARGN})
		print_found (${arg})
	endforeach()
	foreach (arg ${ARGN})
		if (NOT ${arg}_FOUND)
			MESSAGE(FATAL_ERROR " ${arg} not found")
		endif ()
	endforeach ()
endfunction()

macro (option_or_system _PREFIX _LIB)

	# Set configured defaults
	if (NOT DEFINED ${_PREFIX}_INCLUDE_DIRS)
		set (${_PREFIX}_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}" )
	endif ()
	if (NOT DEFINED ${_PREFIX}_LIBRARY_DIRS)
		set (${_PREFIX}_LIBRARY_DIRS "${DEFAULT_LIBRARY_DIRS}" )
	endif ()

	# Override with CLI options
	if (DEFINED ${_PREFIX}_INCDIR)
		set (${_PREFIX}_INCLUDE_DIRS ${${_PREFIX}_INCDIR} )
	endif ()
	if (DEFINED ${_PREFIX}_LIBDIR)
		set (${_PREFIX}_LIBRARY_DIRS ${${_PREFIX}_LIBDIR} )
	endif ()

	# Check expected elements are present
	find_library (${_PREFIX}_LIBRARIES ${_LIB} ${${_PREFIX}_LIBRARY_DIRS})
	set (_FOUND true)
	set (_HEADERS "")
	foreach (arg ${ARGN})
		if (_FOUND)
			find_file (_HEADER ${arg} ${${_PREFIX}_INCLUDE_DIRS})
			if (NOT _HEADER OR _HEADER MATCHES ".*NOTFOUND$")
				set (_FOUND false)
			else ()
				set (_HEADERS "${_HEADERS}:${_HEADER}")
			endif ()
			unset(_HEADER CACHE)
		endif ()
	endforeach ()

	if (NOT ${_PREFIX}_LIBRARIES OR ${_PREFIX}_LIBRARIES MATCHES ".*NOTFOUND$")
		set (${_PREFIX}_FOUND true )
	endif ()
	set (${_PREFIX}_FOUND ${_FOUND})
	set (${_PREFIX}_HEADER "${_HEADERS}")
	unset(_FOUND CACHE)
	unset(_HEADERS CACHE)
endmacro ()

macro(bin_prefix T N)
	if (NOT DEFINED EXE_PREFIX)
		set(EXE_PREFIX "oio")
	endif ()
	set_target_properties(${T} PROPERTIES OUTPUT_NAME ${EXE_PREFIX}${N})
endmacro ()

###-------------------------------------------------------------------------###

dir2macro("GCLUSTER_RUN_DIR")
dir2macro("GCLUSTER_ETC_DIR")

dir2macro("GCLUSTER_CONFIG_FILE_PATH")
dir2macro("GCLUSTER_CONFIG_DIR_PATH")
dir2macro("GCLUSTER_CONFIG_LOCAL_PATH")
dir2macro("GCLUSTER_AGENT_SOCK_PATH")

dir2macro("OIO_EVT_BEANSTALKD_DEFAULT_TUBE")

dir2macro("OIO_ETC_DIR")
dir2macro("OIO_CONFIG_FILE_PATH")
dir2macro("OIO_CONFIG_DIR_PATH")
dir2macro("OIO_CONFIG_LOCAL_PATH")
dir2macro("OIO_DEFAULT_STGPOL")
dir2macro("OIO_DEFAULT_CHUNKMETHOD")
dir2macro("OIO_DEFAULT_MIMETYPE")

dir2macro("PROXYD_PREFIX")
dir2macro("PROXYD_HEADER_PREFIX")
dir2macro("PROXYD_HEADER_MODE")
dir2macro("PROXYD_HEADER_REQID")
dir2macro("PROXYD_HEADER_NOEMPTY")

dir2macro("SQLX_DIR_SCHEMAS")
dir2macro("SQLX_ADMIN_PREFIX_SYS")
dir2macro("SQLX_ADMIN_PREFIX_USER")
dir2macro("SQLX_ADMIN_INITFLAG")
dir2macro("SQLX_ADMIN_STATUS")
dir2macro("SQLX_ADMIN_REFERENCE")
dir2macro("SQLX_ADMIN_BASENAME")
dir2macro("SQLX_ADMIN_BASETYPE")
dir2macro("SQLX_ADMIN_NAMESPACE")

dir2macro("M2V2_ADMIN_PREFIX_SYS")
dir2macro("M2V2_ADMIN_PREFIX_USER")
dir2macro("M2V2_ADMIN_VERSION")
dir2macro("M2V2_ADMIN_QUOTA")
dir2macro("M2V2_ADMIN_SIZE")
dir2macro("M2V2_ADMIN_CTIME")
dir2macro("M2V2_ADMIN_VERSIONING_POLICY")
dir2macro("M2V2_ADMIN_STORAGE_POLICY")
dir2macro("M2V2_ADMIN_KEEP_DELETED_DELAY")

dir2macro("META2_INIT_FLAG")

dir2macro("DAEMON_DEFAULT_TIMEOUT_READ")
dir2macro("DAEMON_DEFAULT_TIMEOUT_ACCEPT")

dir2macro("OIO_USE_OLD_FMEMOPEN")

include(Variables.CMakeFile)

###-------------------------------------------------------------------------###

if (NOT DEFINED CMAKE_INSTALL_PREFIX)
	set (CMAKE_INSTALL_PREFIX "/usr/local")
endif ()
MESSAGE(STATUS "Installation prefix : ${CMAKE_INSTALL_PREFIX}")


if (LD_LIBEXECDIR)
	MESSAGE("LD_LIBEXECDIR explicitely set to ${LD_LIBEXECDIR}")
else ()
	set (LD_LIBEXECDIR "libexec")
	MESSAGE("LD_LIBEXECDIR set to ${LD_LIBEXECDIR} (default)")
endif ()

if (LD_LIBDIR)
	MESSAGE("LD_LIBDIR explicitely set to ${LD_LIBDIR}")
else()
	CHECK_TYPE_SIZE(long SIZEOF_LONG)
	MESSAGE(STATUS "sizeof(long) = ${SIZEOF_LONG}")
	if (SIZEOF_LONG EQUAL 8)
		set (LD_LIBDIR "lib64")
	else ()
		set (LD_LIBDIR "lib")
	endif ()
	MESSAGE("LD_LIBDIR set to ${LD_LIBDIR} (default)")
endif()

if (PKGCONFIG_DIRECTORY)
	MESSAGE("PKGCONFIG_DIRECTORY explicitely set to ${PKGCONFIG_DIRECTORY}")
else ()
	set(PKGCONFIG_DIRECTORY "${CMAKE_INSTALL_PREFIX}/${LD_LIBDIR}/pkgconfig")
	MESSAGE("PKGCONFIG_DIRECTORY set to ${PKGCONFIG_DIRECTORY} (default)")
endif ()

set (GRIDD_PLUGINS_DIRECTORY "${LD_LIBDIR}/grid")
if (DEFINED GRIDD_PLUGINS)
	set(GRIDD_PLUGINS_DIRECTORY "${GRIDD_PLUGINS}")
endif ()

###-------------------------------------------------------------------------###

# Set defaults
set(DEFAULT_LIBRARY_DIRS "/usr/${LD_LIBDIR}")
set(DEFAULT_INCLUDE_DIRS "/usr/include")
set(APACHE2_LIBRARY_DIRS "${DEFAULT_LIBRARY_DIRS}/httpd")
set(APACHE2_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/httpd")
set(ATTR_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/attr")
set(ZK_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/zookeeper")

# check system configuration
pkg_search_module(JSONC json json-c)
pkg_check_modules(GLIB2 REQUIRED glib-2.0 gthread-2.0 gmodule-2.0)
pkg_check_modules(CURL curl libcurl)

if (NOT SDK_ONLY)
pkg_check_modules(APR REQUIRED apr-1)
pkg_check_modules(SQLITE3 REQUIRED sqlite3)
pkg_check_modules(ZMQ libzmq>=4.0.0)
# Optional cache libraries
pkg_search_module(HIREDIS hiredis)
pkg_search_module(LIBMEMCACHED libmemcached)

endif (NOT SDK_ONLY)

# Load CLI-overriden configuration
option_or_system(CURL curl curl/curl.h)
option_or_system(JSONC json-c json.h)

if (NOT SDK_ONLY)
option_or_system(APACHE2 modules/mod_webdav.so httpd.h)
option_or_system(ATTR attr attr/xattr.h)
option_or_system(ZK zookeeper_mt zookeeper.h)
option_or_system(ZLIB z zlib.h)
option_or_system(ZMQ zmq zmq.h zmq_utils.h)
option_or_system(LEVELDB leveldb leveldb/c.h)

if (ASN1C_EXE)
	set(ASN1C_EXECUTABLE ${ASN1C_EXE})
else()
	find_program(ASN1C_EXECUTABLE asn1c)
endif()
set(ASN1C_EXE_OPTS "-fwide-types")
endif (NOT SDK_ONLY)

if (NOT SDK_ONLY)
test_CLI(FLEX_EXECUTABLE "flex")
test_CLI(BISON_EXECUTABLE "bison")
test_CLI(ASN1C_EXECUTABLE "asn1c")
endif(NOT SDK_ONLY)

# Check every required module is present

=== cache/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.cache")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

add_library(oiocache SHARED cache.c cache_noop.c cache_lru.c cache_multilayer.c)
target_link_libraries(oiocache metautils ${GLIB2_LIBRARIES})

install(TARGETS oiocache
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin
		PUBLIC_HEADER DESTINATION include)

if (DEFINED ALLOW_HIREDIS)
	if (HIREDIS_FOUND)
		add_library(oiocache_redis SHARED cache_redis.c)
		target_link_libraries(oiocache_redis ${HIREDIS_LIBRARIES})

		install(TARGETS oiocache_redis
				LIBRARY DESTINATION ${LD_LIBDIR}
				RUNTIME DESTINATION bin
				PUBLIC_HEADER DESTINATION include)
	endif ()
endif ()

if (DEFINED ALLOW_LIBMEMCACHED)
	if (LIBMEMCACHED_FOUND)
		add_library(oiocache_memcached SHARED cache_memcached.c)
		target_link_libraries(oiocache_memcached ${LIBMEMCACHED_LIBRARIES})

		install(TARGETS oiocache_memcached
				LIBRARY DESTINATION ${LD_LIBDIR}
				RUNTIME DESTINATION bin
				PUBLIC_HEADER DESTINATION include)
	endif ()
endif ()

=== core/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.core")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_BINARY_DIR})

include_directories(AFTER
		${GLIB2_INCLUDE_DIRS}
		${CURL_INCLUDE_DIRS}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${GLIB2_LIBRARY_DIRS}
		${CURL_LIBRARY_DIRS}
		${JSONC_LIBRARY_DIRS})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/client_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/client_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"client"
		${CMAKE_SOURCE_DIR}/conf.json)

add_library(oiocore SHARED url.c cfg.c str.c ext.c log.c lb.c var.c
	${CMAKE_CURRENT_BINARY_DIR}/client_variables.h
	${CMAKE_CURRENT_BINARY_DIR}/client_variables.c)

target_link_libraries(oiocore
		${JSONC_LIBRARIES} ${GLIB2_LIBRARIES})
set_target_properties(oiocore PROPERTIES
		PUBLIC_HEADER "oio_core.h"
		SOVERSION ${ABI_VERSION})

add_library(oiosds SHARED
	http_put.c
	http_del.c
	headers.c
	proxy.c
	sds.c dir.c cs.c)
target_link_libraries(oiosds oiocore
		${GLIB2_LIBRARIES} ${CURL_LIBRARIES} ${JSONC_LIBRARIES})
set_target_properties(oiosds PROPERTIES
		PUBLIC_HEADER "oio_sds.h"
		SOVERSION ${ABI_VERSION})

add_executable(tool_sdk_noconf tool_sdk_noconf.c)
target_link_libraries(tool_sdk_noconf oiosds)

add_executable(tool_sdk tool_sdk.c)
target_link_libraries(tool_sdk oiosds)

add_executable(tool_roundtrip tool_roundtrip.c)
target_link_libraries(tool_roundtrip oiosds)

install(FILES
		oiocfg.h
		oiodir.h
		oioext.h
		oiolog.h
		oiostr.h
		oiourl.h
		oiovar.h
		oiocs.h
		oiolb.h
		DESTINATION include/core)

install(TARGETS oiocore oiosds
		LIBRARY DESTINATION ${LD_LIBDIR}
		PUBLIC_HEADER DESTINATION include)

=== events/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.events")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
		${CMAKE_SOURCE_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/metautils/lib)

include_directories(AFTER
		${ZMQ_INCLUDE_DIRS})

link_directories(
		${ZMQ_LIBRARY_DIRS})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/events_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/events_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"events"
		${CMAKE_SOURCE_DIR}/conf.json)

add_library(oioevents SHARED
	oio_events_queue.c
	oio_events_queue_buffer.c
	oio_events_queue_internals.c
	oio_events_queue_fanout.c
	oio_events_queue_zmq.c
	oio_events_queue_beanstalkd.c
	${CMAKE_CURRENT_BINARY_DIR}/events_variables.c)

set_target_properties(oioevents PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(oioevents metautils ${GLIB2_LIBRARIES} ${ZMQ_LIBRARIES})

install(TARGETS oioevents
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin
		PUBLIC_HEADER DESTINATION include)

=== meta0v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m0v2" -DTHREADED)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_SOURCE_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/metautils/lib
		${CMAKE_BINARY_DIR}/metautils/asn1c
		${CMAKE_CURRENT_BINARY_DIR})

include_directories(AFTER
		${ZK_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})

add_library(meta0remote SHARED meta0_remote.c meta0_remote.h)
set_target_properties(meta0remote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0remote
		metautils
		${GLIB2_LIBRARIES})


add_library(meta0utils SHARED meta0_utils.c meta0_utils.h)
set_target_properties(meta0utils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0utils
		metautils gridcluster
		${GLIB2_LIBRARIES})


add_library(meta0v2 SHARED meta0_backend.h meta0_backend.c)
set_target_properties(meta0v2 PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0v2
		meta0utils metautils gridcluster sqliterepo
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})


add_executable(meta0_client meta0_client.c)
bin_prefix(meta0_client -meta0-client)
target_link_libraries(meta0_client gridcluster
		meta0remote meta0utils metautils server)


add_executable(meta0_server
		zk_manager.c
		meta0_gridd_dispatcher.c
		meta0_server.c)
bin_prefix(meta0_server -meta0-server)
target_link_libraries(meta0_server
		meta0v2 meta0utils
        metautils gridcluster server sqliterepo
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta0utils meta0remote meta0v2 meta0_server meta0_client
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

install(TARGETS meta0remote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== meta1v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m1v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_SOURCE_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})

add_library(meta1v2 SHARED
		compound_types.c compound_types.h
		meta1_backend_internals.h
		meta1_backend.h
		meta1_backend.c
		meta1_backend_internals.c
		meta1_backend_services.c
		meta1_backend_properties.c
		meta1_backend_references.c
		meta1_prefixes.c meta1_prefixes.h
		internals.h internals_sqlite.h)

set_target_properties(meta1v2 PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta1v2
		metautils gridcluster sqliterepo
		meta0utils meta0remote
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(meta1remote SHARED meta1_remote.c meta1_remote.h)
set_target_properties(meta1remote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta1remote
		metautils
		${GLIB2_LIBRARIES})

add_executable(meta1_server meta1_gridd_dispatcher.c meta1_server.c)
bin_prefix(meta1_server -meta1-server)
target_link_libraries(meta1_server meta1v2
        meta0utils metautils gridcluster server sqliterepo
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_executable(meta1_client meta1_client.c)
bin_prefix(meta1_client -meta1-client)
target_link_libraries(meta1_client metautils meta1remote)

install(TARGETS meta1v2 meta1_server meta1remote meta1_client
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== meta2v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m2v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/metautils/lib
		${CMAKE_BINARY_DIR}/metautils/asn1c)

include_directories(AFTER
		${JSONC_INCLUDE_DIRS}
		${LIBRAIN_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS}
		${LIBRAIN_LIBRARY_DIRS})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/meta2_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/meta2_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"meta2"
		${CMAKE_SOURCE_DIR}/conf.json)

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/autogen.c
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h
	DEPENDS
		${CMAKE_CURRENT_SOURCE_DIR}/m2gen.py
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_CURRENT_SOURCE_DIR}/m2gen.py
		${CMAKE_CURRENT_BINARY_DIR}
)

add_library(meta2v2utils SHARED
		${CMAKE_CURRENT_BINARY_DIR}/autogen.c
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h
		${CMAKE_CURRENT_BINARY_DIR}/meta2_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/meta2_variables.h
		meta2_macros.h
		meta2_utils_lb.c
		meta2_utils_lb.h
		generic.c
		generic.h
		meta2_utils.c
		meta2_utils.h
		meta2_bean.c
		meta2_bean_utils.c
		meta2_bean.h
		meta2_macros.h
		meta2_dedup_utils.h
		meta2_dedup_utils.c
		meta2_utils_json_in.c
		meta2_utils_json_out.c
		meta2_utils_json.h
)

target_link_libraries(meta2v2utils
		metautils gridcluster sqliteutils
		${LIBRAIN_LIBRARIES}
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${JSONC_LIBRARIES})

add_library(meta2v2 SHARED
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h generic.h
		meta2_utils.h
		meta2_macros.h
		meta2_backend.h
		meta2_backend.c)

target_link_libraries(meta2v2
		metautils sqliterepo
		meta1remote meta0remote meta0utils
		meta2v2utils
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_executable(meta2_server
		meta2_gridd_dispatcher.c
		meta2_filters_extract.c
		meta2_filters_check.c
		meta2_filters_misc.c
		meta2_filters_action_url.c
		meta2_filters_action_container.c
		meta2_filters_action_content.c
		meta2_filter_context.c
		meta2_server.c)
bin_prefix(meta2_server -meta2-server)

target_link_libraries(meta2_server meta2v2
        hcresolve metautils gridcluster server
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta2v2 meta2_server meta2v2utils
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== proxy/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.proxy")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

add_definitions(-DHAVE_UGLY_RC_FUNCTIONS=1)

include_directories(BEFORE
		${CMAKE_SOURCE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_BINARY_DIR})

include_directories(AFTER
		${GLIB2_INCLUDE_DIRS}
		${CURL_INCLUDE_DIRS}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${GLIB2_LIBRARY_DIRS}
		${CURL_LIBRARY_DIRS}
		${JSONC_LIBRARY_DIRS})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/proxy_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/proxy_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"proxy"
		${CMAKE_SOURCE_DIR}/conf.json)

add_executable(metacd_http
    metacd_http.c
    common.c
    admin_actions.c
    cache_actions.c
    cs_actions.c
    lb_actions.c
    dir_actions.c
    m2_actions.c
    sqlx_actions.c
    reply.c
    path_parser.c
    transport_http.c
	${CMAKE_CURRENT_BINARY_DIR}/proxy_variables.c
	meta2v2_remote.c meta2v2_remote.h)

bin_prefix(metacd_http -proxy)

target_link_libraries(metacd_http
		metautils server hcresolve gridcluster
		meta2v2utils
		meta1remote sqlitereporemote
		meta0remote meta0utils
		${GLIB2_LIBRARIES} ${JSONC_LIBRARIES} ${CURL_LIBRARIES})

install(TARGETS metacd_http
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== rdir/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.rdir")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
		${CMAKE_SOURCE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${JSONC_INCLUDE_DIRS}
		${LEVELDB_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${LEVELDB_LIBRARY_DIRS})

### routes.c
# The file is cold-generated by the command:
# `ragel -C -o routes.c routes.c.rl`
# Do we really need another dependency at compile-time? Maybe.

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/rdir_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/rdir_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"rdir"
		${CMAKE_SOURCE_DIR}/conf.json)

add_executable(rdir
		rdir.c
		routes.c routes.h
		rdir_variables.c rdir_variables.h
		../proxy/transport_http.c)

bin_prefix(rdir -rdir-server)

target_link_libraries(rdir metautils oiocore server
	 ${LEVELDB_LIBRARIES})

install(TARGETS rdir
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== resolver/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.resolver")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR})

include_directories(AFTER
		${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/metautils/lib)

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/resolver_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/resolver_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"resolver"
		${CMAKE_SOURCE_DIR}/conf.json)


add_library(hcresolve SHARED
	hc_resolver.c
	${CMAKE_CURRENT_BINARY_DIR}/resolver_variables.c
	${CMAKE_CURRENT_BINARY_DIR}/resolver_variables.h)

target_link_libraries(hcresolve
		meta0remote meta1remote metautils gridcluster
		${GLIB2_LIBRARIES})

install(TARGETS hcresolve
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== server/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.srv")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_BINARY_DIR})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/server_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/server_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"server"
		${CMAKE_SOURCE_DIR}/conf.json)


add_library(server SHARED
		slab.c
		network_server.c
        transport_gridd.c
		${CMAKE_CURRENT_BINARY_DIR}/server_variables.c)

set_target_properties(server PROPERTIES SOVERSION ${ABI_VERSION})

target_link_libraries(server
		metautils
		-lm ${GLIB2_LIBRARIES})

install(TARGETS server
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== sqliterepo/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.sqlite" -DTHREADED)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_SOURCE_DIR}
		${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/metautils/asn1c
		${CMAKE_BINARY_DIR}/metautils/lib
		${CMAKE_CURRENT_BINARY_DIR})

include_directories(AFTER
		${ZK_INCLUDE_DIRS}
		${SQLITE3_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_remote_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_remote_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration (sqliterepo_remote)"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"sqliterepo_remote"
		${CMAKE_SOURCE_DIR}/conf.json)

add_custom_command(
	OUTPUT
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_variables.h
	DEPENDS
		${CMAKE_SOURCE_DIR}/confgen.py
		${CMAKE_SOURCE_DIR}/conf.json
	PRE_BUILD
	COMMENT
		"Generating the central configuration"
	COMMAND
		${PYTHON_EXECUTABLE}
	ARGS
		${CMAKE_SOURCE_DIR}/confgen.py
		"sqliterepo"
		${CMAKE_SOURCE_DIR}/conf.json)


add_library(sqliteutils SHARED rc.c sqlite_utils.c)

set_target_properties(sqliteutils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliteutils metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqlitereporemote SHARED
		sqlx_remote.c
		sqlx_remote_ex.c
		replication_client.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_remote_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_remote_variables.h)

set_target_properties(sqlitereporemote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqlitereporemote metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqliterepo SHARED
		gridd_client_pool.c
		synchro.c
		version.c
		cache.c
		hash.c
		replication.c
		election.c
		replication_dispatcher.c
		repository.c
		restoration.c
		upgrade.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_variables.c
		${CMAKE_CURRENT_BINARY_DIR}/sqliterepo_variables.h)

set_target_properties(sqliterepo PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliterepo metautils
		sqlitereporemote sqliteutils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${ZK_LIBRARIES})

install(TARGETS sqliterepo sqliteutils sqlitereporemote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== debian/changelog ===
openio-sds (4.1.26-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Wed, 20 Jun 2018 09:42:12 +0000

openio-sds (4.1.25-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Wed, 13 Jun 2018 09:21:44 +0000

openio-sds (4.1.24-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 04 Jun 2018 16:18:32 +0000

openio-sds (4.1.23-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 28 May 2018 12:15:56 +0000

openio-sds (4.1.22-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 24 Apr 2018 15:48:41 +0000

openio-sds (4.1.21-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 03 Apr 2018 15:36:27 +0000

openio-sds (4.1.18-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 27 Mar 2018 08:45:23 +0000

openio-sds (4.1.17-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 26 Mar 2018 15:41:56 +0000

openio-sds (4.0.0-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 30 Jun 2017 17:15:42 +0000

openio-sds (3.3.1-2) xenial; urgency=medium

  * Fix the PBR version

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 17:14:59 +0000

openio-sds (3.3.1-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 17:02:50 +0000

openio-sds (3.3.0-1) xenial; urgency=medium

  * New release
  * Change python to C for rdir 

 -- Sebastien Lapierre <sebastien.lapierre@openio.io>  Fri, 12 May 2017 15:19:26 +0000

=== debian/control ===
Source: openio-sds
Section: unknown
Priority: optional
Maintainer: Romain Acciari <romain.acciari@openio.io>
Build-Depends:
 debhelper (>= 9)
 , cmake
 , libglib2.0-dev (>= 2.42)
 , libzookeeper-mt-dev (>= 3.4.5)
 , python-dev
 , python-setuptools
 , libzmq3-dev
 , libcurl4-gnutls-dev
 , libapreq2-dev (>= 1.2)
 , libsqlite3-dev (>= 3.7.11)
 , libattr1-dev (>= 2.4.32)
 , libevent-dev (>= 2.0)
 , apache2 (>= 2.2)
 , apache2-dev (>= 2.2)
 , liblzo2-dev (>= 2.0)
 , openio-gridinit
 , openio-asn1c (>= 0.9.27.1)
 , libdb-dev
 , libjson-c-dev (>= 0.12)
 , flex
 , bison
 , curl
 , python-pbr
 , libleveldb-dev 
Standards-Version: 3.9.5
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://anonscm.debian.org/collab-maint/openio-sds.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/openio-sds.git;a=summary

Package: openio-sds
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , python-xattr (>= 0.8.0) | python-pyxattr (>= 0.4.0)
 , python-eventlet (>= 0.15.2)
 , gunicorn (>= 19.4.5)
 , python-requests (>= 2.6.0)
 , python-flask
 , python-redis
 , apache2
 , libexpat1
 , openio-asn1c (>= 0.9.27.1)
 , libglib2.0-0 (>= 2.42)
 , zlib1g
 , libjson-c2 (>= 0.12)
 , python-zookeeper (>= 3.4.5)
 , libapr1 (>= 1.2)
 , libevent-2.0-5
 , liblzo2-2 (>= 2.0)
 , openio-gridinit
 , libdb5.3
 , python-pbr
 , python-yaml
 , python-plyvel
 , libsqlite3-0 (>= 3.7.11)
 , libleveldb1v5
 , python-simplejson (>= 2.0.9)
 , python-flask
 , python-eventlet
 , python-redis
 , cliff-tablib
 , python-cliff (>= 1.13)
 , python-tablib
 , python-pyeclib (>= 1.2.0)
 , python-concurrent.futures
Description: OpenIO Cloud Storage Solution
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.

Package: openio-sds-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openio-sds (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for openio-sds
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.
 .
 This package contains the debugging symbols for openio-sds.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1
export DH_OPTIONS=-v
export DEB_BUILD_OPTIONS += nocheck
export PBR_VERSION=4.1.26
DESTDIR=$(CURDIR)/debian/openio-sds
PYTHON_SITELIB=$(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem cmake -- \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DLD_LIBDIR="lib" \
	-DEXE_PREFIX="oio" \
	-DZK_LIBDIR="/usr/lib" \
	-DZK_INCDIR="/usr/include/zookeeper" \
	-DLZO_INCDIR="/usr/include/lzo" \
	-DAPACHE2_LIBDIR="/usr/lib/apache2" \
	-DAPACHE2_INCDIR="/usr/include/apache2" \
	-DLIBRAIN_LIBDIR="/usr/lib" \
	-DLIBRAIN_INCDIR="/usr/include" \
	-DSOCKET_OPTIMIZED=1

override_dh_auto_build:
	dh_auto_build --buildsystem cmake
	python setup.py build

override_dh_install:
	dh_install
	python setup.py install -O1 --skip-build --prefix=/usr --install-layout=deb --root $(DESTDIR)
	# Install OpenIO SDS directories
	mkdir -pv $(DESTDIR)/var/log/oio/sds \
		$(DESTDIR)/var/lib/oio/sds \
		$(DESTDIR)/etc/oio/sds \
		$(DESTDIR)/run/oio/sds



# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#       dh_auto_configure -- \
#

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=openio-sds-dbg

override_dh_auto_install:
	dh_auto_install --destdir=debian/openio-sds

## openio-sds 201702061645.gitc1ac0c9

=== meta2v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m2v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${JSONC_INCLUDE_DIRS}
		${LIBRAIN_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS}
		${LIBRAIN_LIBRARY_DIRS})

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/autogen.c ${CMAKE_CURRENT_BINARY_DIR}/autogen.h
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/m2gen.py ${CMAKE_CURRENT_BINARY_DIR}
	DEPENDS m2gen.py
)

add_library(meta2v2utils SHARED
		meta2_utils_lb.c
		meta2_utils_lb.h
		generic.c
		generic.h
		${CMAKE_CURRENT_BINARY_DIR}/autogen.c
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h
		meta2_utils.c
		meta2_utils.h
		meta2_bean.c
		meta2_bean_utils.c
		meta2_bean.h
		meta2_macros.h
		meta2_dedup_utils.h
		meta2_dedup_utils.c
		meta2_utils_json_in.c
		meta2_utils_json_out.c
		meta2_utils_json.h
)

target_link_libraries(meta2v2utils
		metautils gridcluster sqliteutils
		${LIBRAIN_LIBRARIES}
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${JSONC_LIBRARIES})

add_library(meta2v2remote SHARED
		meta2_macros.h
		meta2v2_remote.h
		meta2v2_remote.c)

target_link_libraries(meta2v2remote
		meta2v2utils metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(meta2v2 SHARED
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h generic.h
		meta2_utils.h
		meta2_macros.h
		meta2_backend.h
		meta2_backend.c)

target_link_libraries(meta2v2
		metautils sqliterepo
		meta2v2remote meta1remote meta0remote meta0utils
		meta2v2utils meta2v2remote
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_executable(meta2_server
		meta2_gridd_dispatcher.c
		meta2_filters_extract.c
		meta2_filters_check.c
		meta2_filters_misc.c
		meta2_filters_action_url.c
		meta2_filters_action_container.c
		meta2_filters_action_content.c
		meta2_filters_action_events.c
		meta2_filter_context.c
		meta2_server.c)
bin_prefix(meta2_server -meta2-server)

target_link_libraries(meta2_server meta2v2
        hcresolve metautils gridcluster server
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta2v2 meta2v2remote meta2_server meta2v2utils
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== tools/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.tools")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE ..)

add_executable(echo-server oio-echo-server.c)
bin_prefix(echo-server "-echo-server")
target_link_libraries(echo-server metautils server gridcluster ${GLIB2_LIBRARIES})

add_executable(oio-tool oio-tool.c)
bin_prefix(oio-tool -tool)
target_link_libraries(oio-tool metautils ${GLIB2_LIBRARIES})


set(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/.timestamp")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-unlock-all.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-unlock-all.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-flush-all.sh
                ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-flush-all.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-wait-scored.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-wait-scored.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-reset.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-reset.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-bootstrap.py
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-bootstrap.py
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-sds.pc.in
        ${CMAKE_CURRENT_BINARY_DIR}/oio-sds.pc
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-test-config.py
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-test-config.py
        @ONLY)

add_custom_command(OUTPUT ${OUTPUT}
                   COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
                   DEPENDS ${DEPS})

add_custom_target(tools ALL DEPENDS ${OUTPUT})

install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/oio-sds.pc
        DESTINATION ${PKGCONFIG_DIRECTORY}
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(TARGETS
            echo-server
            oio-tool
        DESTINATION bin)

install(PROGRAMS
            zk-bootstrap.py
            zk-reset.py
            oio-election-reset.py
            oio-election-smudge.py
            oio-election-dump.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-unlock-all.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-flush-all.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-wait-scored.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-bootstrap.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-test-config.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-reset.sh
        DESTINATION bin)
